# coding: utf-8
# Copyright 2023 Ant Group CO., Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.rest.configuration import Configuration


class ObjectStoreResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"relative_path": "str", "absolute_path": "str"}

    attribute_map = {"relative_path": "relativePath", "absolute_path": "absolutePath"}

    def __init__(
        self, relative_path=None, absolute_path=None, local_vars_configuration=None
    ):  # noqa: E501
        """ObjectStoreResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._relative_path = None
        self._absolute_path = None
        self.discriminator = None

        self.relative_path = relative_path
        self.absolute_path = absolute_path

    @property
    def relative_path(self):
        """Gets the relative_path of this ObjectStoreResponse.  # noqa: E501


        :return: The relative_path of this ObjectStoreResponse.  # noqa: E501
        :rtype: str
        """
        return self._relative_path

    @relative_path.setter
    def relative_path(self, relative_path):
        """Sets the relative_path of this ObjectStoreResponse.


        :param relative_path: The relative_path of this ObjectStoreResponse.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation
            and relative_path is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `relative_path`, must not be `None`"
            )  # noqa: E501

        self._relative_path = relative_path

    @property
    def absolute_path(self):
        """Gets the absolute_path of this ObjectStoreResponse.  # noqa: E501


        :return: The absolute_path of this ObjectStoreResponse.  # noqa: E501
        :rtype: str
        """
        return self._absolute_path

    @absolute_path.setter
    def absolute_path(self, absolute_path):
        """Sets the absolute_path of this ObjectStoreResponse.


        :param absolute_path: The absolute_path of this ObjectStoreResponse.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation
            and absolute_path is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `absolute_path`, must not be `None`"
            )  # noqa: E501

        self._absolute_path = absolute_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ObjectStoreResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ObjectStoreResponse):
            return True

        return self.to_dict() != other.to_dict()
